!**********************************************************************************************************************
! xFunction Library v2.8 include file
! Copyright 2001-2010, SealSoft Company
!**********************************************************************************************************************

      SECTION('CONSTANTS')

VK_CONTROL                        EQUATE(11h)
KEYEVENTF_EXTENDEDKEY             EQUATE(0001h)
KEYEVENTF_KEYUP                   EQUATE(0002h)
LANG:Rus                          EQUATE(1)
LANG:Eng                          EQUATE(2)

DriversQueue                      QUEUE,TYPE
DriveChar                           STRING(1)
DriveType                           BYTE
                                  END

DRIVE_RAMDISK                     EQUATE(1)
DRIVE_REMOVABLE                   EQUATE(2)
DRIVE_FIXED                       EQUATE(3)
DRIVE_REMOTE                      EQUATE(4)
DRIVE_CDROM                       EQUATE(5)

xf_BIF_BROWSEFORCOMPUTER          EQUATE(01000h)     ! To look computers
xf_BIF_BROWSEFORPRINTER           EQUATE(02000h)     ! To look printers
xf_BIF_BROWSEINCLUDEFILES         EQUATE(04000h)     ! To look files
xf_BIF_RETURNONLYFSDIRS           EQUATE(00001h)     ! Only system folders
xf_BIF_NEWDIALOGSTYLE             EQUATE(0040h)      ! A "new" kind of a window
xf_BIF_EDITBOX                    EQUATE(0010h)      ! To show a field for input

xf_CSIDL_NETWORK                  EQUATE(00012h)     ! A network
xf_CSIDL_PRINTERS                 EQUATE(00004h)     ! Printers

xf_BROWSE_INFO_TYPE               GROUP,TYPE
hwndOwner                           ULONG ! handle windows of "owner"
pidlRoot                            LONG  ! The address on the list
pszDisplayName                      LONG  ! The address for the line
lpszTitle                           LONG  ! The address for the line
ulFlags                             ULONG ! Flags
lpfn                                LONG  ! The address on callback-function
lParam                              LONG
iImage                              LONG
                                  END

XFRECT                            GROUP,TYPE
Left                                SIGNED
Top                                 SIGNED
Right                               SIGNED
Bottom                              SIGNED
                                  END
      SECTION('PROTOTYPES')

!=======================================================================================================================
xInitLibrary            PROCEDURE
!=======================================================================================================================
! Date time function
!=======================================================================================================================
xAgeCalculate           PROCEDURE(LONG  Birthday), STRING
xGetZodiac              PROCEDURE(LONG  Birthday, *STRING ZodiacSign), BYTE, PROC
xGetChineYear           PROCEDURE(LONG  Year,     *STRING ChineYear), BYTE, PROC
xGetDayName             PROCEDURE(<LONG InpDate>, <BYTE NameType>), STRING
xGetDayNumber           PROCEDURE(<LONG InpDate>), BYTE
xLeapYear               PROCEDURE(<LONG InDate>), SHORT
xMonthOfYear            PROCEDURE(<LONG InDate>, <BYTE Mode>), STRING
xQuartOfYear            PROCEDURE(<LONG InDate>), BYTE
xWeekOfYear             PROCEDURE(<LONG InDate>), BYTE
xWeekOfMonth            PROCEDURE(<LONG InDate>), BYTE
xIsLastDayOfMonth       PROCEDURE(<LONG InDate>), BYTE
xLastDayOfMonth         PROCEDURE(<LONG InDate>), LONG
xDayOfYear              PROCEDURE(<LONG InDate>), SHORT
xDaysLeftInYear         PROCEDURE(<LONG InDate>), SHORT
xSetPeriodLastWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodCurrWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodNextWeek      PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodLastMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodCurrMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodNextMonth     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodLastQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodCurrQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetPeriodNextQuart     PROCEDURE(*LONG LowDate, *LONG HighDate)
xSetEngMonth            PROCEDURE(BYTE Mon, STRING MonthName)
xSetEngDay              PROCEDURE(BYTE Day, STRING DayName)
xSetRusZodiac           PROCEDURE(BYTE SignNum, STRING SignName)
xSetEngZodiac           PROCEDURE(BYTE SignNum, STRING SignName)
xSetRusChineYear        PROCEDURE(BYTE SignNum, STRING SignName)
xSetEngChineYear        PROCEDURE(BYTE SignNum, STRING SignName)

!=======================================================================================================================
! File and path function
!=======================================================================================================================
xCheckForSubfolders     PROCEDURE(STRING ParentDirectory), BYTE
xCopyFile               PROCEDURE(STRING PassedSource, STRING PassedTarget), BYTE
xMoveFile               PROCEDURE(STRING PassedSource, STRING PassedTarget), BYTE
xCreateDir              PROCEDURE(STRING InPath), BYTE
xCreateTreeDir          PROCEDURE(STRING Tree), BYTE
xDeleteFile             PROCEDURE(STRING PassedFile), BYTE
xNormDir                PROCEDURE(STRING InPath),STRING
xDeNormDir              PROCEDURE(STRING InPath), STRING
xExtractExt             PROCEDURE(STRING INP:Path), STRING
xExtractFile            PROCEDURE(STRING INP:Path), STRING
xExtractFileName        PROCEDURE(STRING INP:Path), STRING
xExtractPath            PROCEDURE(STRING Inp:Path), STRING
xFindFile               PROCEDURE(STRING PassedFile), BYTE
xGetFileAttr            PROCEDURE(STRING PassFile, LONG Attr), BYTE
xSetFileAttr            PROCEDURE(STRING PassFile, LONG Attr), BYTE
xPathExists             PROCEDURE(STRING INP:Path),BYTE
xRemovePathFromFileName PROCEDURE(*STRING FileName1, *STRING Path), STRING
xGetRelativePath        PROCEDURE(STRING FileName), STRING
xGetDrivers             PROCEDURE(*DriversQueue Drv)
xGetFileSize            PROCEDURE(STRING FileName), LONG
xGetTempPath            PROCEDURE(),STRING
xGetFileDate            PROCEDURE(STRING PassedFile, *LONG FDate, *LONG FTime),BYTE

!=======================================================================================================================
! Misc function
!=======================================================================================================================
xGenGlobalID            PROCEDURE(), STRING
xGetUniqCode            PROCEDURE(FILE F_File, KEY K_Key, *LONG V_Var), LONG
xGetConfig              PROCEDURE(FILE FilesName), BYTE,PROC
xPutConfig              PROCEDURE(FILE FilesName), BYTE,PROC
xOpenFolder             PROCEDURE(STRING OpenPath)
xSetLanguage            PROCEDURE(BYTE Language)
xGetFileVersion         PROCEDURE(STRING FFileName),STRING

!=======================================================================================================================
! Extended standard function
!=======================================================================================================================
xReplace                PROCEDURE(*STRING Into, STRING Find, STRING Replace)
xReplace                PROCEDURE(*CSTRING Into, STRING Find, STRING Replace)
xQuote                  PROCEDURE(STRING Into),STRING
xDelay                  PROCEDURE(ULONG Delay)
xHex                    PROCEDURE(BYTE FirstParam), STRING
xLenStr                 PROCEDURE(STRING Line),LONG
xMessage                PROCEDURE(STRING MessageText, <STRING Caption>, <STRING DisplayIcon>, <STRING Buttons>, UNSIGNED DefaultButton=0, BOOL Style=FALSE),UNSIGNED,PROC
xWarning                PROCEDURE(STRING WarningMessage, <BYTE MessageType>), BYTE,PROC

!=======================================================================================================================
! Debug function
!=======================================================================================================================
xDebug                  PROCEDURE(STRING Messages)
xDebugEvent             PROCEDURE(LONG EventParam)

!=======================================================================================================================
! Work with Clarion EMBED editor
!=======================================================================================================================
xPasteToEditor          PROCEDURE(LONG WinHandle, <STRING StrToEditor>)
xCopyFromEditor         PROCEDURE(LONG WinHandle)

!=======================================================================================================================
! Other
!=======================================================================================================================
xGetMemorySize          PROCEDURE(BYTE MemType), REAL
xGetClentRectSize       PROCEDURE(WINDOW Window, *LONG Width, *LONG Height)
!=======================================================================================================================

!=======================================================================================================================
! Network
!=======================================================================================================================
xNetDialog              PROCEDURE(<STRING inTitle>),STRING,PROC
!=======================================================================================================================

      SECTION('CLASSES')

!=======================================================================================================================
! Classes
!=======================================================================================================================
xLabelClass             CLASS,MODULE('xfunc.clw'),TYPE,LINK('xfunc.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
Feq                       LONG
Text                      STRING(100)
Color                     LONG
Init                      PROCEDURE(LONG Feq, LONG Color=0,<STRING Text>)
Show                      PROCEDURE(*? Text)
                        END